<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>sorting-ruby</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>#SORTS</p>
    <ul>
      <li>
        Selection Sort: This algorithm works by examining a contiguous sublist
        of the original list. It finds the nth largest element in the list and
        swaps it with the nth element. It then examines n-1 terms. Selection
        sort runs in Θ(n2) time for worst, bets, and average case scenarios.
      </li>
      <li>
        Bubblesort: This algorithm works by swapping consecutive elements that
        are unordered. It ex- amines two consecutive elements at a time.
        Bubblesort terminates when it completes an iteration through the list
        without swapping any elements. It runs in O(n2) time for average and
        worst cases, and O(n) time if the list is already sorted.
      </li>
      <li>
        Insertion Sort: This algorithm works by examining a larger contiguous
        subset of the original list on each iteration. On the first iteration,
        only elements at indices 0-1 are examined. If they are out of order,
        they are swapped. On the next iteration, elements at indices 0-2 are
        examined. The element at index 2 is pulled out of the list and compared
        against the preceding one-by-one while it is bigger than the given
        element. This process is repeated throughout the entire list. If the
        list is nearly sorted, then insertion sort runs in O(n) time. Otherwise,
        it runs in O(n2) time.
      </li>
      <li>
        Mergesort: This algorithm partitions the list into contiguous sublists
        until each sublist has at most two elements. These elements are swapped
        if necessary. The sublists are then merged into their parent sublists
        such that the elements are properly ordered. Mergesort runs in
        O(nlog(n)) time, and is an ideal sorting algorithm for both arrays and
        linked lists.
      </li>
      <li>
        Quicksort: This algorithm works to sort arrays by ordering elements
        around a partition point. Elements larger than the parttion go to the
        right of it, and elements smaller than the partition go to the left of
        it. Elements equal to the partition value can be placed on either side,
        as long as this is handled consistently. The subsets on either side of
        the partition are then recursively 6 evaluated until contiguous subsets
        of no more than two elements are evaluated.
      </li>
    </ul>
    <h1 id="sample-implementation-of-quicksort-and-mergesort-in-ruby">
      Sample implementation of quicksort and mergesort in ruby
    </h1>
    <p>
      Both algorithm sort in O(n * lg(n)) time Quicksort works inplace, where
      mergesort works in a new array
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode ruby"
      ><code class="sourceCode ruby"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">def</span> quicksort(array, from=<span class="dv">0</span>, to=<span class="dv">nil</span>)</a>
<a class="sourceLine" id="cb1-2" title="2">    <span class="kw">if</span> to == <span class="dv">nil</span></a>
<a class="sourceLine" id="cb1-3" title="3">        <span class="co"># Sort the whole array, by default</span></a>
<a class="sourceLine" id="cb1-4" title="4">        to = array.count - <span class="dv">1</span></a>
<a class="sourceLine" id="cb1-5" title="5">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb1-6" title="6"></a>
<a class="sourceLine" id="cb1-7" title="7">    <span class="kw">if</span> from &gt;= to</a>
<a class="sourceLine" id="cb1-8" title="8">        <span class="co"># Done sorting</span></a>
<a class="sourceLine" id="cb1-9" title="9">        <span class="kw">return</span></a>
<a class="sourceLine" id="cb1-10" title="10">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb1-11" title="11"></a>
<a class="sourceLine" id="cb1-12" title="12">    <span class="co"># Take a pivot value, at the far left</span></a>
<a class="sourceLine" id="cb1-13" title="13">    pivot = array[from]</a>
<a class="sourceLine" id="cb1-14" title="14"></a>
<a class="sourceLine" id="cb1-15" title="15">    <span class="co"># Min and Max pointers</span></a>
<a class="sourceLine" id="cb1-16" title="16">    min = from</a>
<a class="sourceLine" id="cb1-17" title="17">    max = to</a>
<a class="sourceLine" id="cb1-18" title="18"></a>
<a class="sourceLine" id="cb1-19" title="19">    <span class="co"># Current free slot</span></a>
<a class="sourceLine" id="cb1-20" title="20">    free = min</a>
<a class="sourceLine" id="cb1-21" title="21"></a>
<a class="sourceLine" id="cb1-22" title="22">    <span class="kw">while</span> min &lt; max</a>
<a class="sourceLine" id="cb1-23" title="23">        <span class="kw">if</span> free == min <span class="co"># Evaluate array[max]</span></a>
<a class="sourceLine" id="cb1-24" title="24">            <span class="kw">if</span> array[max] &lt;= pivot <span class="co"># Smaller than pivot, must move</span></a>
<a class="sourceLine" id="cb1-25" title="25">                array[free] = array[max]</a>
<a class="sourceLine" id="cb1-26" title="26">                min += <span class="dv">1</span></a>
<a class="sourceLine" id="cb1-27" title="27">                free = max</a>
<a class="sourceLine" id="cb1-28" title="28">            <span class="kw">else</span></a>
<a class="sourceLine" id="cb1-29" title="29">                max -= <span class="dv">1</span></a>
<a class="sourceLine" id="cb1-30" title="30">            <span class="kw">end</span></a>
<a class="sourceLine" id="cb1-31" title="31">        <span class="kw">elsif</span> free == max <span class="co"># Evaluate array[min]</span></a>
<a class="sourceLine" id="cb1-32" title="32">            <span class="kw">if</span> array[min] &gt;= pivot <span class="co"># Bigger than pivot, must move</span></a>
<a class="sourceLine" id="cb1-33" title="33">                array[free] = array[min]</a>
<a class="sourceLine" id="cb1-34" title="34">                max -= <span class="dv">1</span></a>
<a class="sourceLine" id="cb1-35" title="35">                free = min</a>
<a class="sourceLine" id="cb1-36" title="36">            <span class="kw">else</span></a>
<a class="sourceLine" id="cb1-37" title="37">                min += <span class="dv">1</span></a>
<a class="sourceLine" id="cb1-38" title="38">            <span class="kw">end</span></a>
<a class="sourceLine" id="cb1-39" title="39">        <span class="kw">else</span></a>
<a class="sourceLine" id="cb1-40" title="40">            raise <span class="st">&quot;Inconsistent state&quot;</span></a>
<a class="sourceLine" id="cb1-41" title="41">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb1-42" title="42">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb1-43" title="43"></a>
<a class="sourceLine" id="cb1-44" title="44">    array[free] = pivot</a>
<a class="sourceLine" id="cb1-45" title="45"></a>
<a class="sourceLine" id="cb1-46" title="46">    quicksort array, from, free - <span class="dv">1</span></a>
<a class="sourceLine" id="cb1-47" title="47">    quicksort array, free + <span class="dv">1</span>, to</a>
<a class="sourceLine" id="cb1-48" title="48"><span class="kw">end</span></a></code></pre>
    </div>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode ruby"
      ><code class="sourceCode ruby"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">def</span> mergesort(array)</a>
<a class="sourceLine" id="cb2-2" title="2">    <span class="kw">if</span> array.count &lt;= <span class="dv">1</span></a>
<a class="sourceLine" id="cb2-3" title="3">        <span class="co"># Array of length 1 or less is always sorted</span></a>
<a class="sourceLine" id="cb2-4" title="4">        <span class="kw">return</span> array</a>
<a class="sourceLine" id="cb2-5" title="5">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb2-6" title="6"></a>
<a class="sourceLine" id="cb2-7" title="7">    <span class="co"># Apply &quot;Divide &amp; Conquer&quot; strategy</span></a>
<a class="sourceLine" id="cb2-8" title="8"></a>
<a class="sourceLine" id="cb2-9" title="9">    <span class="co"># 1. Divide</span></a>
<a class="sourceLine" id="cb2-10" title="10">    mid = array.count / <span class="dv">2</span></a>
<a class="sourceLine" id="cb2-11" title="11">    part_a = mergesort array.slice(<span class="dv">0</span>, mid)</a>
<a class="sourceLine" id="cb2-12" title="12">    part_b = mergesort array.slice(mid, array.count - mid)</a>
<a class="sourceLine" id="cb2-13" title="13"></a>
<a class="sourceLine" id="cb2-14" title="14">    <span class="co"># 2. Conquer</span></a>
<a class="sourceLine" id="cb2-15" title="15">    array = []</a>
<a class="sourceLine" id="cb2-16" title="16">    offset_a = <span class="dv">0</span></a>
<a class="sourceLine" id="cb2-17" title="17">    offset_b = <span class="dv">0</span></a>
<a class="sourceLine" id="cb2-18" title="18">    <span class="kw">while</span> offset_a &lt; part_a.count &amp;&amp; offset_b &lt; part_b.count</a>
<a class="sourceLine" id="cb2-19" title="19">        a = part_a[offset_a]</a>
<a class="sourceLine" id="cb2-20" title="20">        b = part_b[offset_b]</a>
<a class="sourceLine" id="cb2-21" title="21"></a>
<a class="sourceLine" id="cb2-22" title="22">        <span class="co"># Take the smallest of the two, and push it on our array</span></a>
<a class="sourceLine" id="cb2-23" title="23">        <span class="kw">if</span> a &lt;= b</a>
<a class="sourceLine" id="cb2-24" title="24">            array &lt;&lt; a</a>
<a class="sourceLine" id="cb2-25" title="25">            offset_a += <span class="dv">1</span></a>
<a class="sourceLine" id="cb2-26" title="26">        <span class="kw">else</span></a>
<a class="sourceLine" id="cb2-27" title="27">            array &lt;&lt; b</a>
<a class="sourceLine" id="cb2-28" title="28">            offset_b += <span class="dv">1</span></a>
<a class="sourceLine" id="cb2-29" title="29">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb2-30" title="30">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb2-31" title="31"></a>
<a class="sourceLine" id="cb2-32" title="32">    <span class="co"># There is at least one element left in either part_a or part_b (not both)</span></a>
<a class="sourceLine" id="cb2-33" title="33">    <span class="kw">while</span> offset_a &lt; part_a.count</a>
<a class="sourceLine" id="cb2-34" title="34">        array &lt;&lt; part_a[offset_a]</a>
<a class="sourceLine" id="cb2-35" title="35">        offset_a += <span class="dv">1</span></a>
<a class="sourceLine" id="cb2-36" title="36">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb2-37" title="37"></a>
<a class="sourceLine" id="cb2-38" title="38">    <span class="kw">while</span> offset_b &lt; part_b.count</a>
<a class="sourceLine" id="cb2-39" title="39">        array &lt;&lt; part_b[offset_b]</a>
<a class="sourceLine" id="cb2-40" title="40">        offset_b += <span class="dv">1</span></a>
<a class="sourceLine" id="cb2-41" title="41">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb2-42" title="42"></a>
<a class="sourceLine" id="cb2-43" title="43">    <span class="kw">return</span> array</a>
<a class="sourceLine" id="cb2-44" title="44"><span class="kw">end</span></a></code></pre>
    </div>
    <h1 id="search-a-sorted-array-in-olgn-time">
      Search a sorted array in O(lg(n)) time
    </h1>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode ruby"
      ><code class="sourceCode ruby"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">def</span> binary_search(array, value, from=<span class="dv">0</span>, to=<span class="dv">nil</span>)</a>
<a class="sourceLine" id="cb3-2" title="2">    <span class="kw">if</span> to == <span class="dv">nil</span></a>
<a class="sourceLine" id="cb3-3" title="3">        to = array.count - <span class="dv">1</span></a>
<a class="sourceLine" id="cb3-4" title="4">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb3-5" title="5"></a>
<a class="sourceLine" id="cb3-6" title="6">    mid = (from + to) / <span class="dv">2</span></a>
<a class="sourceLine" id="cb3-7" title="7"></a>
<a class="sourceLine" id="cb3-8" title="8">    <span class="kw">if</span> value &lt; array[mid]</a>
<a class="sourceLine" id="cb3-9" title="9">        <span class="kw">return</span> binary_search array, value, from, mid - <span class="dv">1</span></a>
<a class="sourceLine" id="cb3-10" title="10">    <span class="kw">elsif</span> value &gt; array[mid]</a>
<a class="sourceLine" id="cb3-11" title="11">        <span class="kw">return</span> binary_search array, value, mid + <span class="dv">1</span>, to</a>
<a class="sourceLine" id="cb3-12" title="12">    <span class="kw">else</span></a>
<a class="sourceLine" id="cb3-13" title="13">        <span class="kw">return</span> mid</a>
<a class="sourceLine" id="cb3-14" title="14">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb3-15" title="15"><span class="kw">end</span></a>
<a class="sourceLine" id="cb3-16" title="16"></a>
<a class="sourceLine" id="cb3-17" title="17">a = [<span class="dv">1</span>, <span class="dv">2</span>, <span class="dv">3</span>, <span class="dv">4</span>, <span class="dv">5</span>, <span class="dv">6</span>, <span class="dv">7</span>, <span class="dv">8</span>, <span class="dv">9</span>, <span class="dv">10</span>, <span class="dv">11</span>, <span class="dv">12</span>, <span class="dv">13</span>, <span class="dv">14</span>, <span class="dv">15</span>].shuffle</a>
<a class="sourceLine" id="cb3-18" title="18"><span class="co"># Quicksort operates inplace (i.e. in &quot;a&quot; itself)</span></a>
<a class="sourceLine" id="cb3-19" title="19"><span class="co"># There&#39;s no need to reassign</span></a>
<a class="sourceLine" id="cb3-20" title="20">quicksort a</a>
<a class="sourceLine" id="cb3-21" title="21">puts <span class="st">&quot;quicksort&quot;</span></a>
<a class="sourceLine" id="cb3-22" title="22">puts a</a>
<a class="sourceLine" id="cb3-23" title="23"></a>
<a class="sourceLine" id="cb3-24" title="24">b = [<span class="dv">1</span>, <span class="dv">2</span>, <span class="dv">3</span>, <span class="dv">4</span>, <span class="dv">5</span>, <span class="dv">6</span>, <span class="dv">7</span>, <span class="dv">8</span>, <span class="dv">9</span>, <span class="dv">10</span>, <span class="dv">11</span>, <span class="dv">12</span>, <span class="dv">13</span>, <span class="dv">14</span>, <span class="dv">15</span>].shuffle</a>
<a class="sourceLine" id="cb3-25" title="25"><span class="co"># Mergesort operates in new array</span></a>
<a class="sourceLine" id="cb3-26" title="26"><span class="co"># So we need to reassign</span></a>
<a class="sourceLine" id="cb3-27" title="27">b = mergesort b</a>
<a class="sourceLine" id="cb3-28" title="28">puts <span class="st">&quot;mergesort&quot;</span></a>
<a class="sourceLine" id="cb3-29" title="29">puts b</a>
<a class="sourceLine" id="cb3-30" title="30"></a>
<a class="sourceLine" id="cb3-31" title="31">offset_3 = binary_search a, <span class="dv">3</span></a>
<a class="sourceLine" id="cb3-32" title="32">puts <span class="st">&quot;3 is at offset </span><span class="ot">#{</span>offset_3<span class="ot">}</span><span class="st"> in a&quot;</span></a>
<a class="sourceLine" id="cb3-33" title="33"></a>
<a class="sourceLine" id="cb3-34" title="34">offset_15 = binary_search b, <span class="dv">15</span></a>
<a class="sourceLine" id="cb3-35" title="35">puts <span class="st">&quot;15 is at offset </span><span class="ot">#{</span>offset_15<span class="ot">}</span><span class="st"> in b&quot;</span></a></code></pre>
    </div>
    <h1
      id="write-a-program-to-print-a-2d-array-n-x-m-in-spiral-order-clockwise"
    >
      Write a program to print a 2D array (n x m) in spiral order (clockwise)
    </h1>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode ruby"
      ><code class="sourceCode ruby"><a class="sourceLine" id="cb4-1" title="1"><span class="co"># Input sample:</span></a>
<a class="sourceLine" id="cb4-2" title="2"><span class="co">#</span></a>
<a class="sourceLine" id="cb4-3" title="3"><span class="co"># 3;3;1 2 3 4 5 6 7 8 9</span></a>
<a class="sourceLine" id="cb4-4" title="4"><span class="co">#</span></a>
<a class="sourceLine" id="cb4-5" title="5"><span class="co"># Output sample:</span></a>
<a class="sourceLine" id="cb4-6" title="6"><span class="co">#</span></a>
<a class="sourceLine" id="cb4-7" title="7"><span class="co"># Print out the matrix in clockwise fashion, one per line, space delimited. eg.</span></a>
<a class="sourceLine" id="cb4-8" title="8"><span class="co">#</span></a>
<a class="sourceLine" id="cb4-9" title="9"><span class="co"># 1 2 3 6 9 8 7 4 5</span></a>
<a class="sourceLine" id="cb4-10" title="10"></a>
<a class="sourceLine" id="cb4-11" title="11"><span class="kw">def</span> spiral_print matrix, rows, cols</a>
<a class="sourceLine" id="cb4-12" title="12">  sx, sy = <span class="dv">0</span>, <span class="dv">0</span></a>
<a class="sourceLine" id="cb4-13" title="13">  ex, ey = cols<span class="dv">-1</span>, rows<span class="dv">-1</span></a>
<a class="sourceLine" id="cb4-14" title="14">  values = []</a>
<a class="sourceLine" id="cb4-15" title="15"></a>
<a class="sourceLine" id="cb4-16" title="16">  <span class="kw">until</span> sx &gt; ex <span class="kw">or</span> sy &gt; ey <span class="kw">do</span></a>
<a class="sourceLine" id="cb4-17" title="17">    <span class="kw">for</span> c <span class="kw">in</span> sx..ex     <span class="kw">do</span> values &lt;&lt; matrix[sy][c]    <span class="kw">end</span></a>
<a class="sourceLine" id="cb4-18" title="18">    <span class="kw">for</span> r <span class="kw">in</span> sy+<span class="dv">1</span>..ey   <span class="kw">do</span> values &lt;&lt; matrix[r][ex]    <span class="kw">end</span></a>
<a class="sourceLine" id="cb4-19" title="19">    <span class="kw">for</span> c <span class="kw">in</span> <span class="dv">1</span>..ex-sx   <span class="kw">do</span> values &lt;&lt; matrix[ey][ex-c] <span class="kw">end</span> <span class="kw">if</span> sy != ey</a>
<a class="sourceLine" id="cb4-20" title="20">    <span class="kw">for</span> r <span class="kw">in</span> <span class="dv">1</span>..ey-sy<span class="dv">-1</span> <span class="kw">do</span> values &lt;&lt; matrix[ey-r][sx] <span class="kw">end</span> <span class="kw">if</span> sx != ex</a>
<a class="sourceLine" id="cb4-21" title="21"></a>
<a class="sourceLine" id="cb4-22" title="22">    sx += <span class="dv">1</span></a>
<a class="sourceLine" id="cb4-23" title="23">    sy += <span class="dv">1</span></a>
<a class="sourceLine" id="cb4-24" title="24">    ex -= <span class="dv">1</span></a>
<a class="sourceLine" id="cb4-25" title="25">    ey -= <span class="dv">1</span></a>
<a class="sourceLine" id="cb4-26" title="26">  <span class="kw">end</span></a>
<a class="sourceLine" id="cb4-27" title="27"></a>
<a class="sourceLine" id="cb4-28" title="28">  values</a>
<a class="sourceLine" id="cb4-29" title="29"><span class="kw">end</span></a>
<a class="sourceLine" id="cb4-30" title="30"></a>
<a class="sourceLine" id="cb4-31" title="31"><span class="dt">File</span>.open(<span class="dt">ARGV</span>[<span class="dv">0</span>]).each <span class="kw">do</span> |line|</a>
<a class="sourceLine" id="cb4-32" title="32">  data = line.split <span class="ch">&#39;;&#39;</span></a>
<a class="sourceLine" id="cb4-33" title="33">  rows = data[<span class="dv">0</span>].to_i</a>
<a class="sourceLine" id="cb4-34" title="34">  cols = data[<span class="dv">1</span>].to_i</a>
<a class="sourceLine" id="cb4-35" title="35">  values = data[<span class="dv">2</span>].split <span class="ch">&#39; &#39;</span></a>
<a class="sourceLine" id="cb4-36" title="36">  matrix = (<span class="dv">0</span>..rows<span class="dv">-1</span>).map <span class="kw">do</span> |i|</a>
<a class="sourceLine" id="cb4-37" title="37">    values[i*cols, cols]</a>
<a class="sourceLine" id="cb4-38" title="38">  <span class="kw">end</span></a>
<a class="sourceLine" id="cb4-39" title="39"></a>
<a class="sourceLine" id="cb4-40" title="40">  puts spiral_print(matrix, rows, cols).join(<span class="ch">&#39; &#39;</span>)</a>
<a class="sourceLine" id="cb4-41" title="41"><span class="kw">end</span></a></code></pre>
    </div>
    <p>#Linked List</p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode ruby"
      ><code class="sourceCode ruby"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">class</span> <span class="dt">List</span></a>
<a class="sourceLine" id="cb5-2" title="2">    <span class="ot">attr_accessor</span> <span class="st">:head</span>, <span class="st">:tail</span></a>
<a class="sourceLine" id="cb5-3" title="3"></a>
<a class="sourceLine" id="cb5-4" title="4">    <span class="kw">def</span> initialize(*args)</a>
<a class="sourceLine" id="cb5-5" title="5">        <span class="ot">@head</span> = args.pop</a>
<a class="sourceLine" id="cb5-6" title="6">        <span class="ot">@tail</span> = <span class="dv">nil</span></a>
<a class="sourceLine" id="cb5-7" title="7"></a>
<a class="sourceLine" id="cb5-8" title="8">        process(args)</a>
<a class="sourceLine" id="cb5-9" title="9">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-10" title="10"></a>
<a class="sourceLine" id="cb5-11" title="11">    <span class="kw">def</span> insert_first(val)</a>
<a class="sourceLine" id="cb5-12" title="12">        new_node = <span class="dt">List</span>.new(<span class="ot">@head</span>)</a>
<a class="sourceLine" id="cb5-13" title="13">        new_node.tail = <span class="ot">@tail</span></a>
<a class="sourceLine" id="cb5-14" title="14"></a>
<a class="sourceLine" id="cb5-15" title="15">        <span class="ot">@head</span> = val</a>
<a class="sourceLine" id="cb5-16" title="16">        <span class="ot">@tail</span> = new_node</a>
<a class="sourceLine" id="cb5-17" title="17">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-18" title="18"></a>
<a class="sourceLine" id="cb5-19" title="19">    <span class="kw">def</span> insert_after(node, new_data, cur_nodes=<span class="dv">self</span>)</a>
<a class="sourceLine" id="cb5-20" title="20">        <span class="kw">if</span>(cur_nodes.head == node)</a>
<a class="sourceLine" id="cb5-21" title="21">            new_node = <span class="dt">List</span>.new(new_data)</a>
<a class="sourceLine" id="cb5-22" title="22">            new_node.tail = cur_nodes.tail</a>
<a class="sourceLine" id="cb5-23" title="23">            cur_nodes.tail = new_node</a>
<a class="sourceLine" id="cb5-24" title="24">        <span class="kw">else</span></a>
<a class="sourceLine" id="cb5-25" title="25">            insert_after(node, new_data, cur_nodes.tail)</a>
<a class="sourceLine" id="cb5-26" title="26">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-27" title="27">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-28" title="28"></a>
<a class="sourceLine" id="cb5-29" title="29">    <span class="co"># Find the count</span></a>
<a class="sourceLine" id="cb5-30" title="30">    <span class="kw">def</span> count</a>
<a class="sourceLine" id="cb5-31" title="31">        <span class="kw">if</span> <span class="ot">@tail</span> == <span class="dv">nil</span></a>
<a class="sourceLine" id="cb5-32" title="32">            count = <span class="dv">1</span></a>
<a class="sourceLine" id="cb5-33" title="33">        <span class="kw">else</span></a>
<a class="sourceLine" id="cb5-34" title="34">            count = <span class="dv">1</span> + <span class="ot">@tail</span>.count</a>
<a class="sourceLine" id="cb5-35" title="35">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-36" title="36">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-37" title="37"></a>
<a class="sourceLine" id="cb5-38" title="38">    <span class="dt">Get</span> the last item</a>
<a class="sourceLine" id="cb5-39" title="39">    <span class="kw">def</span> last</a>
<a class="sourceLine" id="cb5-40" title="40">        <span class="kw">if</span> <span class="ot">@tail</span> == <span class="dv">nil</span></a>
<a class="sourceLine" id="cb5-41" title="41">            <span class="ot">@head</span></a>
<a class="sourceLine" id="cb5-42" title="42">        <span class="kw">else</span></a>
<a class="sourceLine" id="cb5-43" title="43">            <span class="ot">@tail</span>.last</a>
<a class="sourceLine" id="cb5-44" title="44">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-45" title="45">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-46" title="46"></a>
<a class="sourceLine" id="cb5-47" title="47">    <span class="co"># Reverse</span></a>
<a class="sourceLine" id="cb5-48" title="48">    <span class="kw">def</span> reverse(new_list=<span class="dt">List</span>.new(<span class="ot">@head</span>), cur_list=<span class="ot">@tail</span>)</a>
<a class="sourceLine" id="cb5-49" title="49">        <span class="kw">if</span> cur_list == <span class="dv">nil</span></a>
<a class="sourceLine" id="cb5-50" title="50">            new_list</a>
<a class="sourceLine" id="cb5-51" title="51">        <span class="kw">else</span></a>
<a class="sourceLine" id="cb5-52" title="52">            new_list.insert_first(cur_list.head)</a>
<a class="sourceLine" id="cb5-53" title="53">            reverse(new_list,cur_list.tail)</a>
<a class="sourceLine" id="cb5-54" title="54">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-55" title="55">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-56" title="56"><span class="kw">private</span></a>
<a class="sourceLine" id="cb5-57" title="57">    <span class="kw">def</span> process(args)</a>
<a class="sourceLine" id="cb5-58" title="58">        <span class="kw">if</span> !args.empty?</a>
<a class="sourceLine" id="cb5-59" title="59">            x = args.pop()</a>
<a class="sourceLine" id="cb5-60" title="60">            insert_first(x)</a>
<a class="sourceLine" id="cb5-61" title="61">            process(args)</a>
<a class="sourceLine" id="cb5-62" title="62">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-63" title="63">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb5-64" title="64"><span class="kw">end</span></a></code></pre>
    </div>
    <p>#Binary Tree with Breadth First Search</p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode ruby"
      ><code class="sourceCode ruby"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">class</span> <span class="dt">BinTree</span></a>
<a class="sourceLine" id="cb6-2" title="2"></a>
<a class="sourceLine" id="cb6-3" title="3">    <span class="ot">attr_accessor</span> <span class="st">:left</span>, <span class="st">:right</span>, <span class="st">:val</span></a>
<a class="sourceLine" id="cb6-4" title="4"></a>
<a class="sourceLine" id="cb6-5" title="5">    <span class="kw">def</span> initialize(val)</a>
<a class="sourceLine" id="cb6-6" title="6">        <span class="ot">@left</span> = <span class="dv">nil</span></a>
<a class="sourceLine" id="cb6-7" title="7">        <span class="ot">@right</span> = <span class="dv">nil</span></a>
<a class="sourceLine" id="cb6-8" title="8">        <span class="ot">@val</span> = val</a>
<a class="sourceLine" id="cb6-9" title="9">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-10" title="10"></a>
<a class="sourceLine" id="cb6-11" title="11">    <span class="kw">def</span> insert_node(new_val)</a>
<a class="sourceLine" id="cb6-12" title="12">        <span class="kw">if</span> new_val &lt; <span class="ot">@val</span></a>
<a class="sourceLine" id="cb6-13" title="13">            <span class="kw">if</span>(<span class="ot">@left</span> == <span class="dv">nil</span>)</a>
<a class="sourceLine" id="cb6-14" title="14">                <span class="ot">@left</span> = <span class="dt">BinTree</span>.new(new_val)</a>
<a class="sourceLine" id="cb6-15" title="15">            <span class="kw">else</span></a>
<a class="sourceLine" id="cb6-16" title="16">                <span class="ot">@left</span>.insert_node(new_val)</a>
<a class="sourceLine" id="cb6-17" title="17">            <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-18" title="18">        <span class="kw">elsif</span>(new_val &gt; <span class="ot">@val</span>)</a>
<a class="sourceLine" id="cb6-19" title="19">            <span class="kw">if</span>(<span class="ot">@right</span> == <span class="dv">nil</span>)</a>
<a class="sourceLine" id="cb6-20" title="20">                <span class="ot">@right</span> = <span class="dt">BinTree</span>.new(new_val)</a>
<a class="sourceLine" id="cb6-21" title="21">            <span class="kw">else</span></a>
<a class="sourceLine" id="cb6-22" title="22">                <span class="ot">@right</span>.insert_node(new_val)</a>
<a class="sourceLine" id="cb6-23" title="23">            <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-24" title="24">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-25" title="25">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-26" title="26"></a>
<a class="sourceLine" id="cb6-27" title="27"></a>
<a class="sourceLine" id="cb6-28" title="28">    <span class="co"># Searching the Tree for search_val but not the ideal search</span></a>
<a class="sourceLine" id="cb6-29" title="29">    <span class="kw">def</span> search_bfs(search_val)</a>
<a class="sourceLine" id="cb6-30" title="30">        <span class="co"># Start our queue and Visited list</span></a>
<a class="sourceLine" id="cb6-31" title="31">        queue = <span class="dt">Queue</span>.new</a>
<a class="sourceLine" id="cb6-32" title="32">        visited = []</a>
<a class="sourceLine" id="cb6-33" title="33"></a>
<a class="sourceLine" id="cb6-34" title="34">        <span class="co"># adds root tree to queue</span></a>
<a class="sourceLine" id="cb6-35" title="35">        <span class="co"># adds to visited list</span></a>
<a class="sourceLine" id="cb6-36" title="36">        queue.enq(<span class="dv">self</span>)</a>
<a class="sourceLine" id="cb6-37" title="37">        visited.push(<span class="dv">self</span>)</a>
<a class="sourceLine" id="cb6-38" title="38"></a>
<a class="sourceLine" id="cb6-39" title="39">        <span class="kw">while</span> !queue.empty?</a>
<a class="sourceLine" id="cb6-40" title="40">            current_node = queue.deq</a>
<a class="sourceLine" id="cb6-41" title="41"></a>
<a class="sourceLine" id="cb6-42" title="42">            <span class="co"># Check if current_node val == search_val</span></a>
<a class="sourceLine" id="cb6-43" title="43">            <span class="kw">if</span> current_node.val == search_val</a>
<a class="sourceLine" id="cb6-44" title="44">                <span class="kw">return</span> current_node</a>
<a class="sourceLine" id="cb6-45" title="45">            <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-46" title="46"></a>
<a class="sourceLine" id="cb6-47" title="47">            <span class="kw">if</span> current_node.left &amp;&amp; !visited.include?(current_node.left)</a>
<a class="sourceLine" id="cb6-48" title="48">                queue.enq(current_node.left)</a>
<a class="sourceLine" id="cb6-49" title="49">                visited.push(current_node.left)</a>
<a class="sourceLine" id="cb6-50" title="50">            <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-51" title="51"></a>
<a class="sourceLine" id="cb6-52" title="52">            <span class="kw">if</span> current_node.right &amp;&amp; !visited.include?(current_node.right)</a>
<a class="sourceLine" id="cb6-53" title="53">                queue.enq(current_node.right)</a>
<a class="sourceLine" id="cb6-54" title="54">                visited.push(current_node.right)</a>
<a class="sourceLine" id="cb6-55" title="55">            <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-56" title="56">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-57" title="57">        <span class="st">&quot;none!&quot;</span></a>
<a class="sourceLine" id="cb6-58" title="58">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-59" title="59"></a>
<a class="sourceLine" id="cb6-60" title="60"></a>
<a class="sourceLine" id="cb6-61" title="61">      <span class="co">#Better</span></a>
<a class="sourceLine" id="cb6-62" title="62">    <span class="kw">def</span> search(val)</a>
<a class="sourceLine" id="cb6-63" title="63">        <span class="kw">if</span> <span class="ot">@val</span> == val</a>
<a class="sourceLine" id="cb6-64" title="64">            <span class="kw">return</span> <span class="dv">self</span></a>
<a class="sourceLine" id="cb6-65" title="65">        <span class="kw">elsif</span> <span class="ot">@val</span> &gt; val &amp;&amp; <span class="ot">@left</span></a>
<a class="sourceLine" id="cb6-66" title="66">            <span class="kw">return</span> <span class="ot">@left</span>.search(val)</a>
<a class="sourceLine" id="cb6-67" title="67">        <span class="kw">elsif</span> <span class="ot">@val</span> &lt; val &amp;&amp; <span class="ot">@right</span></a>
<a class="sourceLine" id="cb6-68" title="68">            <span class="kw">return</span> <span class="ot">@right</span>.search(val)</a>
<a class="sourceLine" id="cb6-69" title="69">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-70" title="70"></a>
<a class="sourceLine" id="cb6-71" title="71">        <span class="kw">return</span> <span class="st">&quot;Not Found!&quot;</span></a>
<a class="sourceLine" id="cb6-72" title="72">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-73" title="73"></a>
<a class="sourceLine" id="cb6-74" title="74"><span class="kw">end</span></a>
<a class="sourceLine" id="cb6-75" title="75"></a>
<a class="sourceLine" id="cb6-76" title="76"></a>
<a class="sourceLine" id="cb6-77" title="77"></a>
<a class="sourceLine" id="cb6-78" title="78"><span class="kw">class</span> <span class="dt">Tree</span></a>
<a class="sourceLine" id="cb6-79" title="79">    <span class="ot">attr_accessor</span> <span class="st">:children</span>, <span class="st">:val</span></a>
<a class="sourceLine" id="cb6-80" title="80"></a>
<a class="sourceLine" id="cb6-81" title="81">    <span class="kw">def</span> initialize(val)</a>
<a class="sourceLine" id="cb6-82" title="82">        <span class="ot">@val</span> = val</a>
<a class="sourceLine" id="cb6-83" title="83">        <span class="ot">@children</span> = []</a>
<a class="sourceLine" id="cb6-84" title="84">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-85" title="85"></a>
<a class="sourceLine" id="cb6-86" title="86">    <span class="kw">def</span> insert(val)</a>
<a class="sourceLine" id="cb6-87" title="87">      <span class="ot">@children</span>.push(<span class="dt">Tree</span>.new(val))</a>
<a class="sourceLine" id="cb6-88" title="88">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-89" title="89"></a>
<a class="sourceLine" id="cb6-90" title="90">    <span class="co"># Searching the Tree for search_val</span></a>
<a class="sourceLine" id="cb6-91" title="91">    <span class="kw">def</span> search_bfs(search_val)</a>
<a class="sourceLine" id="cb6-92" title="92">        <span class="co"># Start our queue and Visited list</span></a>
<a class="sourceLine" id="cb6-93" title="93">        queue = <span class="dt">Queue</span>.new</a>
<a class="sourceLine" id="cb6-94" title="94">        visited = []</a>
<a class="sourceLine" id="cb6-95" title="95"></a>
<a class="sourceLine" id="cb6-96" title="96">        <span class="co"># adds root tree to queue</span></a>
<a class="sourceLine" id="cb6-97" title="97">        <span class="co"># adds to visited list</span></a>
<a class="sourceLine" id="cb6-98" title="98">        queue.enq(<span class="dv">self</span>)</a>
<a class="sourceLine" id="cb6-99" title="99">        visited.push(<span class="dv">self</span>)</a>
<a class="sourceLine" id="cb6-100" title="100"></a>
<a class="sourceLine" id="cb6-101" title="101">        <span class="kw">while</span> !queue.empty?</a>
<a class="sourceLine" id="cb6-102" title="102">            current_node = queue.deq</a>
<a class="sourceLine" id="cb6-103" title="103"></a>
<a class="sourceLine" id="cb6-104" title="104">            <span class="co"># Check if current_node val == search_val</span></a>
<a class="sourceLine" id="cb6-105" title="105">            <span class="kw">if</span> current_node.val == search_val</a>
<a class="sourceLine" id="cb6-106" title="106">                <span class="kw">return</span> current_node</a>
<a class="sourceLine" id="cb6-107" title="107">            <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-108" title="108"></a>
<a class="sourceLine" id="cb6-109" title="109">            current_node.children.each <span class="kw">do</span> |child|</a>
<a class="sourceLine" id="cb6-110" title="110">                <span class="kw">if</span> !visited.include?(child)</a>
<a class="sourceLine" id="cb6-111" title="111">                    queue.enq(child)</a>
<a class="sourceLine" id="cb6-112" title="112">                    visited.push(child)</a>
<a class="sourceLine" id="cb6-113" title="113">                <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-114" title="114">            <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-115" title="115">        <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-116" title="116">        <span class="st">&quot;none!&quot;</span></a>
<a class="sourceLine" id="cb6-117" title="117">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb6-118" title="118"><span class="kw">end</span></a></code></pre>
    </div>
    <p>#What Happens When You Type In A URL</p>
    <pre><code>
browser checks cache; if requested object is in cache and is fresh, skip to #9
browser asks OS for server&#39;s IP address
OS makes a DNS lookup and replies the IP address to the browser
browser opens a TCP connection to server (this step is much more complex with HTTPS)
browser sends the HTTP request through TCP connection
browser receives HTTP response and may close the TCP connection, or reuse it for another request
if cacheable, response is stored in cache
browser decodes response (e.g. if it&#39;s gzipped)
browser determines what to do with response (e.g. is it a HTML page, is it an image, is it a sound clip?)
browser renders response, or offers a download dialog for unrecognized types</code></pre>
    <p>#AutoComplete Tree</p>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode ruby"
      ><code class="sourceCode ruby"><a class="sourceLine" id="cb8-1" title="1"><span class="kw">class</span> <span class="dt">WordTreeNode</span></a>
<a class="sourceLine" id="cb8-2" title="2">  <span class="ot">attr_accessor</span> <span class="st">:value</span>, <span class="st">:children</span>, <span class="st">:complete</span></a>
<a class="sourceLine" id="cb8-3" title="3"></a>
<a class="sourceLine" id="cb8-4" title="4">  <span class="kw">def</span> initialize(value = <span class="st">&#39;&#39;</span>, complete = <span class="dv">false</span>)</a>
<a class="sourceLine" id="cb8-5" title="5">    <span class="ot">@value</span>    = value</a>
<a class="sourceLine" id="cb8-6" title="6">    <span class="ot">@children</span> = []</a>
<a class="sourceLine" id="cb8-7" title="7">    <span class="ot">@complete</span> = complete</a>
<a class="sourceLine" id="cb8-8" title="8">  <span class="kw">end</span></a>
<a class="sourceLine" id="cb8-9" title="9"></a>
<a class="sourceLine" id="cb8-10" title="10">  <span class="kw">def</span> learn(word)</a>
<a class="sourceLine" id="cb8-11" title="11">    <span class="co"># Chop the string such that it&#39;s one character</span></a>
<a class="sourceLine" id="cb8-12" title="12">    <span class="co"># longer than the value of the current node</span></a>
<a class="sourceLine" id="cb8-13" title="13">    stem = word[<span class="dv">0</span> .. value.length]</a>
<a class="sourceLine" id="cb8-14" title="14"></a>
<a class="sourceLine" id="cb8-15" title="15">    <span class="co"># We are on the last step if the stem is equal to the word</span></a>
<a class="sourceLine" id="cb8-16" title="16">    complete = stem == word</a>
<a class="sourceLine" id="cb8-17" title="17"></a>
<a class="sourceLine" id="cb8-18" title="18">    <span class="co"># Look for a child with value == stem</span></a>
<a class="sourceLine" id="cb8-19" title="19">    node = <span class="ot">@children</span>.find { |child| child.value == stem }</a>
<a class="sourceLine" id="cb8-20" title="20"></a>
<a class="sourceLine" id="cb8-21" title="21">    <span class="co"># Create it if it didn&#39;t exist</span></a>
<a class="sourceLine" id="cb8-22" title="22">    <span class="kw">unless</span> node</a>
<a class="sourceLine" id="cb8-23" title="23">      node = <span class="dt">WordTreeNode</span>.new(stem, complete)</a>
<a class="sourceLine" id="cb8-24" title="24">      <span class="ot">@children</span>.push node</a>
<a class="sourceLine" id="cb8-25" title="25">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb8-26" title="26"></a>
<a class="sourceLine" id="cb8-27" title="27">    <span class="co"># The node may already exist but not marked as complete...</span></a>
<a class="sourceLine" id="cb8-28" title="28">    node.complete ||= <span class="dv">true</span> <span class="kw">if</span> complete</a>
<a class="sourceLine" id="cb8-29" title="29"></a>
<a class="sourceLine" id="cb8-30" title="30">    <span class="co"># Recurse unless this was a complete word</span></a>
<a class="sourceLine" id="cb8-31" title="31">    <span class="co"># </span><span class="al">NOTE</span><span class="co">: using the stem here is a bad idea</span></a>
<a class="sourceLine" id="cb8-32" title="32">    node.learn(word) <span class="kw">unless</span> complete</a>
<a class="sourceLine" id="cb8-33" title="33">  <span class="kw">end</span></a>
<a class="sourceLine" id="cb8-34" title="34"></a>
<a class="sourceLine" id="cb8-35" title="35">  <span class="co"># Returns all complete words in this subtree</span></a>
<a class="sourceLine" id="cb8-36" title="36">  <span class="kw">def</span> words</a>
<a class="sourceLine" id="cb8-37" title="37">    <span class="co"># Count ourselves if we are a complete word</span></a>
<a class="sourceLine" id="cb8-38" title="38">    words = <span class="dv">self</span>.complete ? [<span class="dv">self</span>] : []</a>
<a class="sourceLine" id="cb8-39" title="39"></a>
<a class="sourceLine" id="cb8-40" title="40">    <span class="ot">@children</span>.reduce(words) <span class="kw">do</span> |words, subtree|</a>
<a class="sourceLine" id="cb8-41" title="41">      words += subtree.words</a>
<a class="sourceLine" id="cb8-42" title="42">      words</a>
<a class="sourceLine" id="cb8-43" title="43">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb8-44" title="44">  <span class="kw">end</span></a>
<a class="sourceLine" id="cb8-45" title="45"></a>
<a class="sourceLine" id="cb8-46" title="46">  <span class="kw">def</span> completions_for(str)</a>
<a class="sourceLine" id="cb8-47" title="47">    <span class="co"># Stem our input string as above</span></a>
<a class="sourceLine" id="cb8-48" title="48">    stem = str[<span class="dv">0</span> .. value.length]</a>
<a class="sourceLine" id="cb8-49" title="49"></a>
<a class="sourceLine" id="cb8-50" title="50">    completions = []</a>
<a class="sourceLine" id="cb8-51" title="51">    <span class="kw">if</span> stem == str &amp;&amp; stem.length == value.length</a>
<a class="sourceLine" id="cb8-52" title="52">      <span class="co"># we want to return ALL complete words below</span></a>
<a class="sourceLine" id="cb8-53" title="53">      <span class="co"># the current node because our tree node values</span></a>
<a class="sourceLine" id="cb8-54" title="54">      <span class="co"># are now longer than our input string</span></a>
<a class="sourceLine" id="cb8-55" title="55">      completions += words</a>
<a class="sourceLine" id="cb8-56" title="56">    <span class="kw">else</span></a>
<a class="sourceLine" id="cb8-57" title="57">      <span class="co"># Still walking down the tree</span></a>
<a class="sourceLine" id="cb8-58" title="58"></a>
<a class="sourceLine" id="cb8-59" title="59">      <span class="co"># Count the current node if it&#39;s a complete word</span></a>
<a class="sourceLine" id="cb8-60" title="60">      completions &lt;&lt; <span class="dv">self</span> <span class="kw">if</span> <span class="dv">self</span>.complete</a>
<a class="sourceLine" id="cb8-61" title="61"></a>
<a class="sourceLine" id="cb8-62" title="62">      <span class="co"># Find the subtree that matches the stem</span></a>
<a class="sourceLine" id="cb8-63" title="63">      subtree = <span class="ot">@children</span>.find { |child| child.value == stem }</a>
<a class="sourceLine" id="cb8-64" title="64"></a>
<a class="sourceLine" id="cb8-65" title="65">      <span class="co"># If it exists, we want the completions underneath it</span></a>
<a class="sourceLine" id="cb8-66" title="66">      completions += subtree.completions_for(str) <span class="kw">unless</span> subtree.nil?</a>
<a class="sourceLine" id="cb8-67" title="67">    <span class="kw">end</span></a>
<a class="sourceLine" id="cb8-68" title="68"></a>
<a class="sourceLine" id="cb8-69" title="69">    <span class="co"># Return the array of complete nodes</span></a>
<a class="sourceLine" id="cb8-70" title="70">    completions</a>
<a class="sourceLine" id="cb8-71" title="71">  <span class="kw">end</span></a>
<a class="sourceLine" id="cb8-72" title="72"><span class="kw">end</span></a>
<a class="sourceLine" id="cb8-73" title="73"></a>
<a class="sourceLine" id="cb8-74" title="74">tree = <span class="dt">WordTreeNode</span>.new</a>
<a class="sourceLine" id="cb8-75" title="75">tree.learn <span class="st">&#39;apple&#39;</span></a>
<a class="sourceLine" id="cb8-76" title="76">tree.learn <span class="st">&#39;ape&#39;</span></a>
<a class="sourceLine" id="cb8-77" title="77">tree.learn <span class="st">&#39;app&#39;</span></a>
<a class="sourceLine" id="cb8-78" title="78">tree.learn <span class="st">&#39;appear&#39;</span></a>
<a class="sourceLine" id="cb8-79" title="79">tree.learn <span class="st">&#39;approve&#39;</span></a>
<a class="sourceLine" id="cb8-80" title="80">tree.learn <span class="st">&#39;appease&#39;</span></a>
<a class="sourceLine" id="cb8-81" title="81">tree.learn <span class="st">&#39;boo&#39;</span></a>
<a class="sourceLine" id="cb8-82" title="82">tree.learn <span class="st">&#39;book&#39;</span></a>
<a class="sourceLine" id="cb8-83" title="83">tree.learn <span class="st">&#39;books&#39;</span></a>
<a class="sourceLine" id="cb8-84" title="84">tree.learn <span class="st">&#39;bored&#39;</span></a>
<a class="sourceLine" id="cb8-85" title="85"></a>
<a class="sourceLine" id="cb8-86" title="86">p tree.completions_for(<span class="ch">&#39;a&#39;</span>).map &amp;<span class="st">:value</span> <span class="co"># =&gt; [&quot;app&quot;, &quot;apple&quot;, &quot;appear&quot;, &quot;appease&quot;, &quot;approve&quot;, &quot;ape&quot;]</span></a>
<a class="sourceLine" id="cb8-87" title="87">p tree.completions_for(<span class="st">&#39;ap&#39;</span>).map &amp;<span class="st">:value</span> <span class="co"># =&gt; [&quot;app&quot;, &quot;apple&quot;, &quot;appear&quot;, &quot;appease&quot;, &quot;approve&quot;, &quot;ape&quot;]</span></a>
<a class="sourceLine" id="cb8-88" title="88">p tree.completions_for(<span class="st">&#39;appe&#39;</span>).map &amp;<span class="st">:value</span> <span class="co"># =&gt; [&quot;app&quot;, &quot;appear&quot;, &quot;appease&quot;]</span></a>
<a class="sourceLine" id="cb8-89" title="89">p tree.completions_for(<span class="st">&#39;appr&#39;</span>).map &amp;<span class="st">:value</span> <span class="co"># =&gt; [&quot;app&quot;, &quot;approve&quot;]</span></a>
<a class="sourceLine" id="cb8-90" title="90">p tree.completions_for(<span class="ch">&#39;b&#39;</span>).map &amp;<span class="st">:value</span> <span class="co"># =&gt; [&quot;boo&quot;, &quot;book&quot;, &quot;books&quot;, &quot;bored&quot;]</span></a>
<a class="sourceLine" id="cb8-91" title="91">p tree.completions_for(<span class="st">&#39;bo&#39;</span>).map &amp;<span class="st">:value</span> <span class="co"># =&gt; [&quot;boo&quot;, &quot;book&quot;, &quot;books&quot;, &quot;bored&quot;]</span></a>
<a class="sourceLine" id="cb8-92" title="92">p tree.completions_for(<span class="st">&#39;bor&#39;</span>).map &amp;<span class="st">:value</span> <span class="co"># =&gt; [&quot;bored&quot;]</span></a></code></pre>
    </div>
  </body>
</html>
